<?php
/*
  
	osCommRes, Services Oline 
	http://www.oscommres.com 
	Copyright (c) 2005 osCommRes 
	
	Freeway eCommerce 
	http://www.zac-ware.com/freeway 
	Copyright (c) 2007 ZacWare
	
	Released under the GNU General Public License
*/


// Set flag that this is a parent file
	define( '_FEXEC', 1 );
	

  require('includes/application_top.php');

// if the customer is not logged on, redirect them to the login page
  if (!$FSESSION->is_registered('customer_id')) {
    $navigation->set_snapshot(array('mode' => 'SSL', 'page' => FILENAME_CHECKOUT_EVENT_PAYMENT));
    tep_redirect(tep_href_link(FILENAME_LOGIN, '', 'SSL'));
  }

// if there is nothing in the customers cart, redirect them to the shopping cart page
  if ($event_cart->count_contents() < 1) {
    tep_redirect(tep_href_link(FILENAME_DEFAULT));
  }

// avoid hack attempts during the checkout procedure by checking the internal cartID
  if (isset($event_cart->event_cartID) && $FSESSION->is_registered('event_cartID')) {
    if ($event_cart->event_cartID != $FSESSION->event_cartID) {
      tep_redirect(tep_href_link(FILENAME_CHECKOUT_SHIPPING, '', 'SSL'));
    }
  }

  if (!$FSESSION->is_registered('event_payment')) $FSESSION->set('event_payment',$FREQUEST->postvalue('event_payment'));
  if ($FREQUEST->postvalue('event_payment')) $FSESSION->set('event_payment',$FREQUEST->postvalue('event_payment'));

  if (!$FSESSION->is_registered('event_comments')) $FSESSION->set('event_comments',$FREQUEST->postvalue('event_comments'));
  if (tep_not_null($FREQUEST->postvalue('event_comments'))) {
    $FSESSION->set('event_comments',tep_db_prepare_input($FREQUEST->postvalue('event_comments')));
  }

// load the selected payment module
  require(DIR_WS_CLASSES . 'payment.php');
//  if ($credit_covers) $payment=''; //ICW added for CREDIT CLASS
  $event_payment_modules = new payment($FSESSION->event_payment);
//ICW ADDED FOR CREDIT CLASS SYSTEM
//  require(DIR_WS_CLASSES . 'order_total.php');

  require(DIR_WS_CLASSES . 'reservation.php');
  $reservation = new reservation;

  $event_payment_modules->update_status();
//ICW ADDED FOR CREDIT CLASS SYSTEM
//  $order_total_modules = new order_total;
//ICW ADDED FOR CREDIT CLASS SYSTEM
//  $order_total_modules->collect_posts();
//ICW ADDED FOR CREDIT CLASS SYSTEM
//  $order_total_modules->pre_confirmation_check();

// ICW CREDIT CLASS Amended Line

  $event_payments=$GLOBALS[$FSESSION->event_payment];

  if ( ( is_array($event_payment_modules->modules) && (sizeof($event_payment_modules->modules) > 1) && !is_object($event_payments) ) || (is_object($event_payments) && ($event_payments->enabled == false)) ) {
  if ( (is_array($event_payment_modules->modules)) && (sizeof($event_payment_modules->modules) > 1) && (!is_object($event_payments)) && (!$credit_covers) ) {
    tep_redirect(tep_href_link(FILENAME_CHECKOUT_EVENT_PAYMENT, 'error_message=' . urlencode(ERROR_NO_PAYMENT_MODULE_SELECTED), 'SSL'));
  }

  if (is_array($event_payment_modules->modules)) {
    $event_payment_modules->pre_confirmation_check();
  }
  }
  require(DIR_WS_LANGUAGES . $FSESSION->language . '/' . FILENAME_CHECKOUT_EVENT_CONFIRMATION);

  $breadcrumb->add(NAVBAR_TITLE_1, tep_href_link(FILENAME_CHECKOUT_SHIPPING, '', 'SSL'));
  $breadcrumb->add(NAVBAR_TITLE_2);

  $content = CONTENT_CHECKOUT_EVENT_CONFIRMATION;

  require(DIR_WS_TEMPLATES . TEMPLATE_NAME . '/' . TEMPLATENAME_MAIN_PAGE);

  require(DIR_WS_INCLUDES . 'application_bottom.php');
?>
