<?php
/*
osCommRes, Services Online 
http://www.oscommres.com 
Copyright (c) 2005 osCommRes

Freeway eCommerce 
http://www.zac-ware.com/freeway 
Copyright (c) 2007 ZacWare 

Released under the GNU General Public License
*/
defined('_JEXEC') or die();
defined('_FEXEC') or die();

error_reporting(E_ALL & ~E_NOTICE);

ini_set('session.bug_compat_42',0);
ini_set('session.bug_compat_warn',0);

define('CHECK_CON','');

if (!isset($PHP_SELF)) $PHP_SELF = $_SERVER['PHP_SELF'];

$seo_config =& JFactory::getConfig();
$joomla_seo = $seo_config->getValue('config.sef');		

ini_set('default_charset','iso-8859-1'); //set charset
// start the timer for the page pars	e time log
define('PAGE_PARSE_START_TIME', microtime());
// set the level of error reporting
define('DIR_WS_IMAGES',FREEWAY_FOLDER . 'images' . DS);
define('DIR_WS_INCLUDES',FREEWAY_FOLDER .'includes' .DS);
define('DIR_WS_TEMPLATES',FREEWAY_FOLDER . 'templates' . DS);

$uri = &JFactory::getURI();

	define('DIR_FS_CATALOG',JPATH_BASE . DS);
	$doc_path=$uri->root(true);
	if (strlen($doc_path)>1){
		$doc_path.=DS;
	}
	$home_url = 'http://' . $uri->_host . $doc_path;
	
	define('HTTP_HOME_URL', $home_url);
	define('DIR_WS_HTTP_CATALOG', $doc_path);
	define('DIR_WS_HTTPS_CATALOG', DIR_WS_HTTP_CATALOG);
		

	require(CHECK_CON . FREEWAY_FOLDER .'includes/configure.php');

	include_once(DIR_WS_CLASSES . 'request.php');
	
	$FREQUEST= new phprequest();

	$FGET=&$FREQUEST->getRef('GET');
	$FPOST=&$FREQUEST->getRef('POST');
	
	require(DIR_WS_CLASSES . 'filter_input.php');
  
	if( (isset($FPOST)) || (isset($FGET)) ){
		$INPUT_FILTER = new filter_input();
		if(count($FPOST)>0){
			reset($FPOST);
			while(list($key,) = each($FPOST)){
					 if(!is_array($FPOST[$key])){
					 $FPOST[$key]=$INPUT_FILTER->_cleanTags($FPOST[$key]);
					 }
				}
		}		
		if (count($FGET)>0){
			reset($FGET);	
			while(list($key,) = each($FGET)){
					if(!is_array($FGET[$key])){
					$FGET[$key]=$INPUT_FILTER->_cleanTags($FGET[$key]);
					}
				}	
		}	
	}  
		if (strlen(DB_SERVER) < 1 && is_dir('install')) header('Location: install/index.php');

		// set the type of request (secure or not)
		$request_type = (getenv('HTTPS') == 'on') ? 'SSL' : 'NONSSL';
	
		if ($request_type == 'NONSSL')
			define('DIR_WS_CATALOG', DIR_WS_HTTP_CATALOG);
		else
			define('DIR_WS_CATALOG', DIR_WS_HTTPS_CATALOG);

		$TEMPLATE_MAIN_PAGE='';

		// include the list of project filenames
		require(DIR_WS_INCLUDES . 'filenames.php');
	
		// include the list of project database tables
		require(DIR_WS_INCLUDES . 'database_tables.php');
	
		// include the database functions
		require(DIR_WS_FUNCTIONS . 'database.php');				 	
 
		// make a connection to the database... now
		tep_db_connect() or die('Unable to connect to database server!');

		// set the application parameters
		$configuration_query = tep_db_query('select configuration_key as cfgKey, configuration_value as cfgValue from ' . TABLE_CONFIGURATION);
		while ($configuration = tep_db_fetch_array($configuration_query)) {
			define($configuration['cfgKey'], $configuration['cfgValue']);
		}

		// set the HTTP GET parameters manually if search_engine_friendly_urls is enabled		
		if (SEARCH_ENGINE_FRIENDLY_URLS == 'true' && strpos($REQ_URL,".php")!==false) {
			$path_info=$REQ_URL;
			if(strpos($path_info,".php/")!==false) {
				$path_info=substr($path_info,strpos($path_info,".php/")+4);
				if (strlen($path_info) > 1) {
					$GET_array = array();
					$vars = explode('/', substr($path_info, 1));
					//$vars = explode('/',$path_info);
					for ($i=0, $n=count($vars); $i<$n; $i++) {
						if (strpos($vars[$i], '[]')) {
							$GET_array[substr($vars[$i], 0, -2)][] = $vars[$i+1];
						} else {
							$FREQUEST->setvalue($vars[$i],$vars[$i+1],'GET');
						}
						
						$i++;
					}
					if (sizeof($GET_array) > 0) {
						while (list($key, $value) = each($GET_array))  $FREQUEST->setvalue($key,$value,'GET');
					}
				}
			}
		}		
		// define general functions used application-wide
		require(DIR_WS_FUNCTIONS . 'general.php');  
		require(DIR_WS_FUNCTIONS . 'html_output.php');

		// include cache functions if enabled
		if (USE_CACHE == 'true') include(DIR_WS_FUNCTIONS . 'cache.php');

		// SEF BEGIN  
		require(DIR_WS_CLASSES . 'seo_url.php');
		$SEO_URL = new seo_url;
				
		if ($GLOBALS["SEO_URL"]->enabled){	
			$SEO_URL->restore_seo_url();
		} 
		
		// include shopping cart class
		require(DIR_WS_CLASSES . 'shopping_cart.php');
		require(DIR_WS_CLASSES . "services.php");

		// include navigation history class
		require(DIR_WS_CLASSES . 'navigation_history.php');


		// some code to solve compatibility issues
		require(DIR_WS_FUNCTIONS . 'compatibility.php');
?>
